package cn.com.infosec.asn1.crmf;

import cn.com.infosec.asn1.ASN1Choice;
import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERNull;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERTaggedObject;

public class ProofOfPossession extends ASN1Encodable implements ASN1Choice {
   private int tagNo;
   private ASN1Encodable obj;

   private ProofOfPossession(ASN1TaggedObject tagged) {
      switch (this.tagNo = tagged.getTagNo()) {
         case 0:
            this.obj = DERNull.INSTANCE;
            break;
         case 1:
            this.obj = POPOSigningKey.getInstance(tagged, false);
            break;
         case 2:
         case 3:
            this.obj = POPOPrivKey.getInstance(tagged, false);
            break;
         default:
            throw new IllegalArgumentException("unknown tag: " + this.tagNo);
      }

   }

   public static ProofOfPossession getInstance(Object o) {
      if (o instanceof ProofOfPossession) {
         return (ProofOfPossession)o;
      } else if (o instanceof ASN1TaggedObject) {
         return new ProofOfPossession((ASN1TaggedObject)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   public int getType() {
      return this.tagNo;
   }

   public ASN1Encodable getObject() {
      return this.obj;
   }

   public DERObject toASN1Object() {
      ProofOfPossession var10002 = this;
      int var2 = this.tagNo;
      ASN1Encodable var1 = var10002.obj;
      return new DERTaggedObject(false, var2, var1);
   }
}
